/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * multitou
 * Copyright (C) Chinmay 2010 <>
 * 
 * multitou is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * multitou is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "socket-manager.h"
#include <pthread.h>
pthread_mutex_t lock;
int ret;



/********************** Setting and Getting the Socket Table *************************/
/*
void SocketManager::setSocketTable(int sd)
{
	//boost::mutex::scoped_lock lock(soctabmutex);
	ret = pthread_mutex_lock(&mp);
	s->sockd = sd;
	SS.push_back(s);
	pthread_mutex_unlock(&mp);
}
*/

/*This is called during socket creation
 * at this moment we only need lfd and rfd so these two get initialized in socket manager
 * later these two will be inherited in the socket tables as the tables are created aftr accept function
 */
void SocketManager::initSocketManger(int fakefd, int realfd, struct sockaddr_in *sockettemp)
{
	// cout << "The initSocketManger function" << endl;
	lfd = fakefd;
	rfd = realfd;
	sport = ntohs(sockettemp->sin_port);
	char* ip1 = inet_ntoa(sockettemp->sin_addr);
	std::string ip(ip1);
	sip = ip;

	pthread_mutex_lock(&lock);

	s = new SocketTable();
	s->lfd = fakefd;
	s->realfd = realfd;
	s->sip = ip;
	s->sport = sport;
	SS.push_back(s);

	pthread_mutex_unlock(&lock);

}

void SocketManager::setSocketTableFake(int realfd, int lfd, int afd )
{
	// cout << "The setSocketTableFake function" << endl;
	s = getSocketTable(realfd);

	pthread_mutex_lock(&lock);
	s->accfd = afd;
	s->sip = sip;
	s->sport = sport;
	s->lfd = lfd;
	s->realfd = realfd;
	SS.push_back(s);
	pthread_mutex_unlock(&lock);
}

void SocketManager::setSocketTableAll(int rfd, int lfd, int afd)
{
	//cout << "The setSocketTableAll function" << endl;

	pthread_mutex_lock(&lock);
	s = new SocketTable;
	s->lfd = lfd;
	s->realfd = rfd;
	s->accfd = afd;
	SS.push_back(s);
	pthread_mutex_unlock(&lock);
}

void SocketManager::insertSocketMap(int sd, int faked)
{
	// cout << "The insertSocketMap function" << endl;

	pthread_mutex_lock(&lock);
	s = new SocketTable();
	s->realfd = sd;
	s->lfd = faked;
	socketMap[s->realfd] = s->lfd;
	reverseSocketMap[s->lfd] = s->realfd;
	pthread_mutex_unlock(&lock);

	// cout << "real fd pushed in the vector" << endl;
}

int SocketManager::insertMultiSocketMap(int sd,int list,int backlog)
{

	// cout << "The insertMultiSocketMap function" << endl;
	if ((unsigned int)multiSocketMap.size()==(unsigned int)backlog)
		return -1;
	else
	{
		pthread_mutex_lock(&lock);
		multiSocketMap.insert(pair<int, int>(sd, list));
		pthread_mutex_unlock(&lock);
		return 0;
	}
}

int SocketManager::getRealSocketValue(int sd)
{

	//cout << "The getRealSocketValue function" << endl;
	map<int,int>::iterator iter = reverseSocketMap.find(sd);
	// cout <<"Iterator returns " << endl;
	// cout << iter->first << "   " << iter->second << endl;

	return iter->second;

}

void SocketManager::delSocketTable(int sd)
{
	// cout << "The delSocketTable function" << endl;

	pthread_mutex_lock(&lock);
	for(stbiter=SS.begin(); stbiter!=SS.end(); stbiter++)
	{
		if((*stbiter)->realfd == sd)
		{
			SS.erase(stbiter);
			break;
		}
	}
	pthread_mutex_unlock(&lock);
	
}

struct SocketTable* SocketManager::getSocketTable(int sockfd) 
{
	// cout << "The getSocketTable function" << endl;
	for(stbiter=SS.begin(); stbiter!=SS.end(); stbiter++)
	{
		if((*stbiter)->realfd == sockfd)
		{
			//printSocketTableReal(sockfd);
			return (*stbiter);
		}
		else
		{
			std::cerr <<"Table not found" << endl;
		}
	}
	return NULL;
	
}

struct SocketTable* SocketManager::getSocketTableF(int faked) 
{
	// cout << "The getSocketTableF function" << endl;
	for(stbiter=SS.begin(); stbiter!=SS.end(); stbiter++)
	{
		if((*stbiter)->lfd == faked)
		{
			//printSocketTable((*stbiter)->lfd);
			return (*stbiter);
		}
		else
			std::cerr <<"Table not found" << endl;
	}
	return NULL;
}

struct SocketTable* SocketManager::getSocketTable(string ipadd, u_short port)
{
	// cout << "The getSocketTablebyadd function" << endl;
	for(stbiter=SS.begin(); stbiter!=SS.end(); stbiter++)
	{
		if((*stbiter)->dport == port) //&& !((*stbiter).dip.compare(ipadd)))
			return (*stbiter);
		else
			std::cerr <<"Table not found" << endl;
	}
	return NULL;
}

void SocketManager::setSocketTable(struct sockaddr_in *sockettemp, int sd)
{

	// cout << "The setSocketTableF function" << endl;
	pthread_mutex_lock(&lock);
	s = getSocketTableF(sd);
	s->sport = ntohs(sockettemp->sin_port);
	char* ip1 = inet_ntoa(sockettemp->sin_addr);
	std::string ip(ip1);
	s->sip = ip;
	pthread_mutex_unlock(&lock);
}

void SocketManager::setSocketTableD(struct sockaddr_in *sockettemp, int sd) 
{
    //cout << "The setSocketTableD function" << endl;
	setSocketTableAll(rfd, lfd, sd);

	pthread_mutex_lock(&lock);
	s = getSocketTable(sd);
	char* ip1 = inet_ntoa(sockettemp->sin_addr);
	u_short dport = ntohs(sockettemp->sin_port);
	std::string ip(ip1);
	s->dip = ip;
	s->dport = dport;
	pthread_mutex_unlock(&lock);

	// cout << "Exiting the setSocketTableD function" << endl;

}

void SocketManager::setSocketState(int state, int sd)
{
	// cout << "The setSocketState function" << endl;
	pthread_mutex_lock(&lock);
	s = getSocketTableF(sd);
	s->sockstate = state;
	pthread_mutex_unlock(&lock);
} 


/****************** Printing the different datastructures *****************/
void SocketManager::printSocketTable(int fakefd)
{
	// cout <<endl<< "****Printing the contents of SocketTable****" << endl;
	s = getSocketTableF (fakefd);
	// cout << "Sockd " << s->realfd;
	// cout << " Fakefd " << s->lfd;
	// cout << " Sip " << s->sip;
	// cout << " Sport" << s->sport;
	// cout << " Dip " <<s->dip;
	// cout << " Dport " << s->dport << endl;
}

void SocketManager::printSocketTableReal(int realfd)
{
	// cout <<endl<< "****Printing the contents of SocketTable****" << endl;
	s = getSocketTable (realfd);
	// cout << "Sockd " << s->realfd;
	// cout << " **** Fakefd " << s->lfd;
	// cout << " **** Acceptfd " << s->accfd << endl;
	// cout << " **** Sip " << s->sip;
	// cout << " **** Sport" << s->sport;
	// cout << " **** Dip " <<s->dip;
	// cout << " **** Dport " << s->dport << endl;
}

void SocketManager::printMap()
{
	// cout << endl << "****Printing contents of Map****" << endl;
	map<int, int>::iterator pos;
	
	for(pos = socketMap.begin(); pos != socketMap.end(); ++pos)
	{
		// cout << "Real : " << pos->first << " &&";
		// cout <<" Fake : " << pos->second << endl;
	}
	
	for(pos = reverseSocketMap.begin(); pos != reverseSocketMap.end(); ++pos)
	{
		// cout << "Real : " << pos->first << " &&";
		// cout <<" Fake : " << pos->second << endl;
	}
}

void SocketManager::printMultiMap(int sd)
{
	pair<multimap<int, int>::iterator, multimap<int, int>::iterator> ppp;
	ppp = multiSocketMap.equal_range(sd);
	for (multimap<int, int>::iterator it2 = ppp.first;it2 != ppp.second;++it2)
    {
       // cout << "  [" << (*it2).first << ", " << (*it2).second << "]" << endl;
    }
}

void SocketManager::setTCBState(int una, int nxt, int sd)
{
	pthread_mutex_lock(&lock);
	s = getSocketTable(sd);
	s->tc->snd_nxt = nxt;
	s->tc->snd_una = una;
	pthread_mutex_unlock(&lock);
}

int SocketManager::getTCBState(int sd)
{
	s = getSocketTable(sd);
	return s->tc->snd_nxt;
}

int SocketManager::getTCBStateAck(int sd)
{
	s = getSocketTable(sd);
	return s->tc->snd_una;
}
