/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * multitou
 * Copyright (C) Chinmay 2010 <>
 * 
 * multitou is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * multitou is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _SOCKET_MANAGER_H_
#define _SOCKET_MANAGER_H_
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sstream>
#include <vector>
#include <string>
#include <map>
#include <utility>
using namespace std;
#include "socket-table.h"

class SocketManager : public SocketTable 
{
	public :
		SocketManager()
		{
			s = new SocketTable();
			//setSocketTable(sd);
		}
		struct SocketTable* getSocketTable(int sockd);
		struct SocketTable* getSocketTableF(int fakefd);
	    struct SocketTable* getSocketTable(string ip, u_short port);
	    void initSocketManger(int fakefd, int realfd, struct sockaddr_in *sockettemp);
		void setSocketTable(struct sockaddr_in *, int);
		void setSocketTableAll(int rfd, int lfd, int afd);
		void setSocketTableD(struct sockaddr_in *, int); 
		void setSocketTable(int sockd);
		void delSocketTable(int sockd);
		void setSocketState(int state, int sd);
		void setSocketTableFake(int realfd, int lfd, int afd);
		void insertSocketMap(int realfd, int fakefd);
		void insertReverseSocketMap(int fakefd, int realfd);
		int insertMultiSocketMap(int fakefd, int fdlist, int backlog);
		int getRealSocketValue(int sd);
		void printSocketTable(int fakefd);
		void printSocketTableReal(int realfd);
		void printMap();
		void printMultiMap(int sd);
		void setTCBState(int snd_una, int snd_nxt,int sd);
		int getTCBState(int sd);
		int getTCBStateAck(int sd);
		int lfd;
		int rfd;
		u_short	sport;
		std::string sip;
	
	protected:
		std::vector<SocketTable*> SS;
		std::vector<SocketTable*>::iterator stbiter;
		std::map<int , int > reverseSocketMap;
		std::multimap<int , int > multiSocketMap;	
		std::map<int , int > socketMap;
		SocketTable *s;


};
#endif // _SOCKET_MANAGER_H_
