/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * multitou
 * Copyright (C) Chinmay 2010 <>
 * 
 * multitou is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * multitou is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "tou.h"
#include "globals.h"
#define RECVBUFSIZE 2000

extern int globalFakeFd;

int tou::touSocket(int domain, int type, int protocol)
{
	int sd;
	int yes;
	
	if ((domain != AF_INET) || (type != SOCK_DGRAM) || (protocol != 0 )) {
		cerr << "ERROR CREATING SOCKET" ;
		return -1 ;
	}
	
	sd = socket(domain,type,0);
	
	if(sd == -1 ) {
		cerr << "ERROR CREATING SOCKET" ;
		return -1 ;
	}

	setsockopt(sd, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof(int)); 
	bound = false;
	
	//sm->setSocketTableFake(fakefd);
	sm->insertSocketMap(sd,fakefd);
	//sm->printSocketTable(fakefd);
	sm->printMap ();
	
	return fakefd++;
}

int tou::touBind(int sockfd, struct sockaddr *my_addr, int addrlen)
{
	int res;
	int realfd;
	
	realfd = sm->getRealSocketValue(sockfd);
	res = bind(realfd,my_addr,addrlen);
	
	sm->initSocketManger(sockfd,realfd,(sockaddr_in *)my_addr);
	//sm->printSocketTable (sockfd);

	bound = true;
	cout << " Socket bound " << endl;
	return res;
}

int tou::touListen(int sd, int backlog)
{
	//while accepting check if the sd is in multimap,if not then the socket is not listening hence error
	//TODO : if already listening, return an error.
	//TODO : need to get socket table by lfd..rt nw it is only by afd
	//sm->setSocketState(TOUS_LISTEN,sd);
	// cout << "Socket state set to : " << TOUS_LISTEN << endl;
	int res = sm->insertMultiSocketMap(sd,0,backlog);
	if(res == -1)
		return -1;
	//sm->printMultiMap (sd);
	return 0;
}


int tou::touAccept(int sd, struct sockaddr_in *socket2, socklen_t *addrlen)
{
	cout << "INSIDE ACCEPT \n";
	int getflag = 1;
	int tempfakefd;
	
	int realfd = sm->getRealSocketValue(sd);

	sm->printSocketTableReal(realfd);
	//getflag fcntl is NON_BLOCKING set
	if(getflag)
	{

	}
	tempfakefd = globalFakeFd;
	globalFakeFd++;
	sm->insertMultiSocketMap (sd, tempfakefd,0);
	sm->printMultiMap (sd);

	sm->setSocketTableFake(realfd, sd, tempfakefd);
	sm->setSocketTableD (socket2,realfd);
	sm->setSocketState(TOUS_ESTABLISHED,sd);
	return tempfakefd;

}


int tou::touConnect(int sd, struct sockaddr_in *socket1, int addrlen)
{
	int rv;
	char recvcontent[RECVBUFSIZE];
	struct sockaddr_in sockaddrs;
	touPkg	*tp;
	memset(recvcontent, 0, RECVBUFSIZE);
	cout << "INSIDE CONNECT" << endl;

	int realfd = sm->getRealSocketValue(sd);
	sm->setSocketTableD (socket1,realfd);
	//sm->printSocketTable (sd);

	touPkg ackpkt(0);
	ackpkt.clean();
	int seqnum = generaterandom(realfd);
    ackpkt.putHeaderSeq(seqnum, (u_long)0);
	ackpkt.t.syn = FLAGON;
	// cout << "Sequence number :::: " << seqnum << endl;
	sm->setTCBState(seqnum,0,realfd);


	cout<<"Sending SYN to  :  " << inet_ntoa(socket1->sin_addr)<< "  " <<htons(socket1->sin_port) << endl;
	string tempdata = ackpkt.toString();
	//ackpkt.printall();
	if( -1 <=  (rv = sendto(realfd,tempdata.data(), tempdata.size(), 0,(struct sockaddr*)socket1,sizeof(struct sockaddr_in))))
		perror("SYN send : ");
/****************Send SYN End ****************************/

/*************** Receive SYN ACK **************************/
	// cout <<" *************** Receive SYN ACK" << endl;
 	socklen_t sinlen = sizeof(sockaddrs);
    rv = recvfrom(realfd, recvcontent, RECVBUFSIZE, 0, (struct sockaddr*)&sockaddrs, &sinlen);
	string tempdata1(recvcontent, rv);
	tp = new touPkg(tempdata1);
	// cout<<"Sequence number :::" << tp->t.seq << endl;
	cout<<"Ack Num ::::" << tp->t.ack_seq << endl;
	cout <<"Checking value ::::" <<sm->getTCBStateAck(realfd) << endl;
	if (tp->t.syn == FLAGON && tp->t.ack == FLAGON && int(tp->t.ack_seq) == sm->getTCBStateAck(realfd)+1 )
	{
		sm->setTCBState(tp->t.ack_seq,tp->t.seq,realfd);
		 cout <<"SYN ACK RECEIVED SUCCESSFULLY" << endl;
	}
/***************** Receive SYN ACK End ******************/

/****************** Send ACK ***********************/
	// cout << "****************** Send ACK " << endl;
	touPkg ackpkt1(0);
	ackpkt1.clean();
	u_long seq1 = sm->getTCBStateAck(realfd);
	u_long ackseq1 = sm->getTCBState(realfd)+1;
	// cout << "Sequence number :::: " << seq1 <<endl;
	// cout << "Ack Number :::: " << ackseq1 << endl;
	ackpkt1.putHeaderSeq(seq1, ackseq1);
	ackpkt1.t.ack = FLAGON;
	// cout<<"Sending ACK to  :  " << inet_ntoa(socket1->sin_addr)<< "  " <<htons(socket1->sin_port) << endl;
	string tempdata2 = ackpkt1.toString();
	//ackpkt.printall();
	if( -1 <=  (rv = sendto(realfd,tempdata2.data(), tempdata2.size(), 0,(struct sockaddr*)socket1,sizeof(struct sockaddr_in))))
		perror("send : ");
/******************* Send ACK End ******************/
	return 1;

}

int tou::touSend(int sd, char *buffer, int len, int flag)
{
	int realfd = sm->getRealSocketValue(sd);
	//write to the circular buffer with sd

}

//int tou::touClose(int sd)
//{
//
//	sockaddr_in sockaddrs;
//	SocketTable *s;
//	//sm.setTCB((tp.getSeq()+1), tp.getSeq(),sd);
//	//sm.setTCBRcv(0, sd);
//	s = sm->getSocketTable(sd);
//	// cout << " Inside close  " << endl;
//	if(s->sockstate == TOUS_CLOSE_WAIT)
//	{
//		// cout << "Server side baby " << endl;
//		pthread_create(&closerthread, 0, closer::start_thread, &cl);
//		pthread_join(closerthread, NULL);
//	}
//	else
//	{
//		//tp.clean();
//		//tp.t.seq = s->tc.snd_nxt;
//		u_short port = (s->dport);
//		//assignaddr(&sockaddrs,AF_INET,s->dip,port);
//		//tp.clean();
////		tp.t.seq = 0;
////		tp.t.fin = FLAGON;
////		tp.t.ack_seq = tp.t.seq + 1;
////		// cout << "Sending Fin " << endl;
//		//s->printall();
////		int rv = sendto(sd, &tp, sizeof(tp), 0, (struct sockaddr*)&sockaddrs , sizeof(struct sockaddr_in));
////		tp.printall();
//		/*Client Side */
//		// cout << "Client side baby " << endl;
//		pthread_create(&closerthread, 0, closer::start_thread, &cl);
//		pthread_join(closerthread, NULL);
//	}
//	return 1;
//}

int tou::processTou(int sd)
{

	char recvcontent[RECVBUFSIZE];
	touPkg *tp;
	
	memset(recvcontent, 0, RECVBUFSIZE);
	int rv;

	cout << "INSIDE PROCESSTOU" << endl;
/****************************Receive SYN Start ********************************/
	// cout << "****************************Receive SYN Start " << endl;
	touPkg	pkgack(0);
	struct sockaddr_in sockaddrs;
	//struct sockaddr_in *socket1;
    int realfd = sm->getRealSocketValue(sd);
	socklen_t sinlen = sizeof(sockaddrs);
	rv = recvfrom(realfd, recvcontent, RECVBUFSIZE, 0, (struct sockaddr*)&sockaddrs,&sinlen);
	if (rv == -1)
	{
		perror("Error in receiving the SYN\n");
	}
	else {
		// cout << "Received SYN" << endl;
	}
	string content(recvcontent,RECVBUFSIZE);
	tp = new touPkg(content); 
	////// cout << "SYN is : " << tp->t.syn << endl;
	////// cout << "SEQ is : " << tp->t.seq << endl;
 	if(tp->t.syn==FLAGON)
	{
		int seq1 = generaterandom(sd);
		// cout << "Sequence number :::: " << seq1 <<endl;
		// cout << "Ack Number :::: " << tp->t.seq+1 << endl;
		sm->setTCBState(seq1,tp->t.seq+1,realfd);
		//tp->printall();
		//////// cout << " SYN receivd " << endl;
	}
/*****************************Receive SYN End **********************************/

/****************************Send SYN ACK Start******************************/
	// cout << "****************************Send SYN ACK Start" << endl;
 	touPkg ackpkt(0);
	ackpkt.clean();
	u_long seq1 = sm->getTCBStateAck(realfd);
	u_long ackseq1 = sm->getTCBState(realfd);
	// cout << "Sequence number :::: " << seq1 <<endl;
	// cout << "Ack Number :::: " << ackseq1 << endl;
    ackpkt.putHeaderSeq(seq1, ackseq1);
	ackpkt.t.syn = FLAGON;
	ackpkt.t.ack = FLAGON;
	//// cout << "Sequence number :::: " << seqnum << endl;
	//sm->setTCBState(seqnum,0,realfd);
	////////// cout<<"Sending SYN ACK to  :  " << inet_ntoa(socket1->sin_addr)<< "  " <<htons(socket1->sin_port) << endl;
	string tempdata = ackpkt.toString();
	//ackpkt.printall();
	if( -1 <=  (rv = sendto(realfd,tempdata.data(), tempdata.size(), 0,(struct sockaddr*)&sockaddrs,sinlen)))
		perror("send : ");
/***************************Send SYN ACK End******************************/

/*********************** Receive ACK Start ******************************/
	touPkg	pkgack1(0);
	struct sockaddr_in sockaddrs1;
	rv = recvfrom(realfd, recvcontent, RECVBUFSIZE, 0, (struct sockaddr*)&sockaddrs1,&sinlen);
	string content1(recvcontent, RECVBUFSIZE);
	tp = new touPkg(content1);
	//////// cout << "ACK is : " << tp->t.ack << endl;
	// cout<<"Sequence number :::" << tp->t.seq << endl;
	// cout<<"Ack Num ::::" << tp->t.ack_seq << endl;
	// cout <<"Checking value ::::" <<sm->getTCBStateAck(realfd) << endl;
	if (tp->t.ack == FLAGON && int(tp->t.ack_seq) == sm->getTCBStateAck(realfd)+1 )
	{
		sm->setTCBState(tp->t.ack_seq,tp->t.seq,realfd);
		cout <<"ACK RECEIVED SUCCESSFULLY :: THREE WAY HANDSHAKE COMPLETE" << endl;
	}
/*************************** Receive ACK End ******************************/
	//sleep(5);

	return 0;
}



int tou::toufcntl(int fd,int cmd,long arg)
{
	//get readfd from fakefd
	//use real fcntl
	//return the output
	int realfd = sm->getRealSocketValue(fd);
	int flags;
	if ((flags = fcntl(realfd, F_GETFL, 0)) < 0)
	{
		//////// cout << "Error" << endl;
	}
	if (arg == 0)
	{
		//////// cout <<"Nonblocking !!" << endl;
		if (fcntl(realfd, F_SETFL, flags | O_NONBLOCK) < 0)
		{
			//////// cout << "Error setting non blocking" << endl;
			return -1;
		}
	}
	else
	{
		//////// cout <<"Blocking !!" << endl;
		if (fcntl(realfd, F_SETFL, flags & (~O_NONBLOCK)) < 0)
		{
			//////// cout << "Error setting blocking" << endl;
			return -1;
		}
	}
	//////// cout << " Set the socket successfully" << endl;
	return 0;
}

int tou::generaterandom(int sd)
{
	srand((unsigned)time(0));
	int random_integer = (rand() + sd) % 100;
	////// cout << random_integer << endl;
	return random_integer;
}

void closer::dothis(int sd1)
{
	//int sd1 = (int)& sd;
	//int sd1 = reinterpret_cast<int> (sd);
	char recvcontent[RECVBUFSIZE];
	touPkg *tp;
	memset(recvcontent, 0, RECVBUFSIZE);
	//long long sd2 = reinterpret_cast<long long> (sd1);
	//int sd = static_cast<int>(sd2);
	int sd = sd1;
	int realfd = sm->getRealSocketValue(sd);
	int rv;

	SocketTable *s = sm->getSocketTable(sd);
	{
		sockaddr_in sockaddrs,socket1;
		size_t len = sizeof(sockaddr);
		//tp.t.seq = s->tc.snd_nxt;
		u_short port = (s->dport);
		//assignaddr(&sockaddrs,AF_INET,s->dip,port);
		if(s->sockstate == TOUS_CLOSE_WAIT)
		{
			// cout << " Inside server close " << endl;
			//boost::mutex::scoped_lock lock(socktabmutex1);
			// cout << "Sending FIN ACK " << endl;
			//tp.clean();
//			tp.t.fin = 1;
//			tp.t.ack = 1;
//			tp.t.seq = 2;
//			s->printall();
//			int rv = sendto(sd, &tp, sizeof(tp), 0, (struct sockaddr*)&sockaddrs , sizeof(struct sockaddr_in));
//			tp.printall();
			//tp.clean();
			fd_set socks;
			struct timeval tim;
			FD_ZERO(&socks);
			FD_SET(sd, &socks);
			tim.tv_sec = 5;
			// cout << "waiting for ACK" << endl;
			size_t  len = sizeof(sockaddrs);
			//while(1)
			{
				//if (select(sd+1, &socks, NULL, NULL, &tim))
				{
					// cout << " Waiting 2 MSL and ack" << endl ;
					touPkg	pkgack(0);
						struct sockaddr_in sockaddrs;
						//struct sockaddr_in *socket1;
					    //int realfd = sm->getRealSocketValue(sd);
						socklen_t sinlen = sizeof(sockaddrs);
						rv = recvfrom(realfd, recvcontent, RECVBUFSIZE, 0, (struct sockaddr*)&sockaddrs,&sinlen);
						string content(recvcontent,RECVBUFSIZE);
						tp = new touPkg(content);
					// cout << "after recv from" << endl;
					if(tp->t.ack == 1)
					{
						close(sd);
						//return 1;
					}
				}
				//else
				{
					// cout << " 2 MSL Over "  << endl;
					close(sd);
					//return 1;
				}
			}


		}
		else
		{
			//boost::mutex::scoped_lock lock(socktabmutex1);
			// cout << " Inside client close " << endl;
			sockaddr_in sockaddrs,socket1;
			size_t len = sizeof(sockaddr);
			//tp.t.seq = s->tc.snd_nxt;
			sm->setSocketState(TOUS_FIN_WAIT_1,sd);
			// cout << " Receiving Fin ACK " << endl;
			touPkg	pkgack(0);
				//struct sockaddr_in sockaddrs;
				//struct sockaddr_in *socket1;
			    int realfd = sm->getRealSocketValue(sd);
				socklen_t sinlen = sizeof(sockaddrs);
				rv = recvfrom(realfd, recvcontent, RECVBUFSIZE, 0, (struct sockaddr*)&sockaddrs,&sinlen);
				string content(recvcontent,RECVBUFSIZE);
				tp = new touPkg(content);
			// cout <<" after recv from" << endl;
			//tp.printall();
			if(tp->t.fin ==1 && tp->t.ack ==1) {
				sm->setSocketState(TOUS_TIME_WAIT,sd);
				// cout << " Received FIN ACK" << endl;
			}
			tp->clean();
			tp->t.ack = 1;
			tp->t.seq = 3;
			// cout << " Sending ACK " << endl;
			//s->printall();
			sendto(sd, &tp, sizeof(tp), 0, (struct sockaddr*)&sockaddrs , sizeof(struct sockaddr_in));
			//tp.printall();
			//sm->delSocketTable(sd);
			close(sd);

		}
	}
	// cout << "Work done by the close thread" << endl;
	// cout << "Exiting close thread" << endl;
}
//TODO:::

/*
 * terminate called after throwing an instance of 'std::length_error'
  what():  basic_string::_S_create
Aborted
 */

//TODO:
/*Sequence number random generated for SYN..now store it in some variable and use it in other
 * transactions..use prev code as reference
 */

/*NOTE ::ta
 * 3 way handshake : SYN = 1, cseq
 * 					SYN = ACK = 1, sseq, cseq+1
 * 					ACK = 1, cseq+1. sseq+1
 */


/* TODO :
 *
 * Program received signal SIGSEGV, Segmentation fault.
/*
 *TODO:step 3 if clause
 *TODO:step 4
 */
