/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * multitou
 * Copyright (C) Chinmay 2010 <>
 * 
 * multitou is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * multitou is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _TOU_H_
#define _TOU_H_
typedef	unsigned long 	u_long;
typedef	unsigned short	u_short;
typedef unsigned char	u_char;

/*
 *Timers
 */
#define TOUT_TIMERS			4
#define TOUT_REXMIT			0
#define TOUT_PERSIST		1
#define TOUT_KEEP			2
#define TOUT_2MSL			3
#define MAXCONN				50
/*
 *Ethernet 1500-20-24
 */
#ifndef TOU_MSS
#define TOU_MSS				1456
#endif

/*
 *Status
 */

#define TOUS_CLOSED			0
#define TOUS_LISTEN			1
#define TOUS_SYN_SENT		2
#define TOUS_SYN_RECEIVED	3
#define TOUS_ESTABLISHED	4
#define TOUS_CLOSE_WAIT		5
#define TOUS_FIN_WAIT_1		6
#define TOUS_CLOSING		7
#define TOUS_LAST_ACK		8
#define TOUS_FIN_WAIT_2		9
#define TOUS_TIME_WAIT		10

/***************************************************
 * Include from STD library
 **************************************************/
#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sstream>
#include <vector>
#include <string>
#include <map>
#include "socket-manager.h"



class tou
{
public:
	tou() 
	{
		sm =new SocketManager();
	}

	int touSocket(int socket, int domain, int protocol);
	int touAccept(int socket, struct sockaddr_in *my_addr, socklen_t *len );
	int touConnect(int socket, struct sockaddr_in *my_addr, int len);
	int touBind(int socket, struct sockaddr *my_addr, int len);
	int touListen(int socket, int backlog);
	int touSend(int socket, char *buffer, int len, int flag);
	int touRecv(int socket, char *buffer, int len, int flag);
	int touClose(int socket);
	int touSetSockOpt(int socket, int level, int option_name, const void
                *option_value, socklen_t option_len);
	int processTou (int sockd);
	int tousetsockopt(int socket, int level, int option_name, const void
	                *option_value, socklen_t option_len);
	int toufcntl(int fd, int cmd, long arg);
	int generaterandom(int sd);


	touHeader *th;
protected:
	int bound;
	SocketManager *sm;
};

#endif // _TOU_H_
